import 'dart:async';

export 'widgets/splash_screen.dart';

typedef AsyncFunction<T> = Future<T> Function();

/// UI singleton
class UI {
  /// UI singleton
  factory UI() => _instance;
  UI._privateConstructor();
  static final UI _instance = UI._privateConstructor();

  StreamController<bool> _splashController;

  /// stream of the splash widget
  Stream<bool> get splashStream => _splashController.stream;

  /// function to add events to splash widget
  void Function(bool) get setSplash => _splashController.add;

  /// initialize the singleton
  Future<void> init() async {
    _splashController ??= StreamController<bool>();
  }

  /// dispose the stream controller
  Future<void> dispose() async {
    await _splashController?.close();
  }
}
